/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
//
//
//	LO Perception教材 サーバクラス
//			変更履歴
// 				2004.01.08 新規作成		suzuki
//
package jp.co.ntt.lms.lo.Perception;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.util.*;

import jp.co.ntt.lms.xmo.Lo.MaterialData;	// @pending この教材データオブジェクトは将来パッケージを変える
import jp.co.ntt.lms.xmo.MenuData;
import jp.co.ntt.lms.xmo.MessageData;
import jp.co.ntt.lms.lo.Perception.util.CertificationCipher;
import jp.co.ntt.lms.xmo.Lo.LoClient;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;

import java.util.*;
import java.sql.*;

/**
 * LO Perception教材 サーバクラスです。<BR>
 * 要求を受けたLOのメニューリストを作成して返します
 * RMIサーバとして動作するためRemoteインタフェースであるLoTopインタフェースを実装し、
 * 永続的な起動状態を確保するためjava.rmi.server.UnicastRemoteObjectクラスを継承します。
 * @author T.Suzuki
 * @version 0.0.0.1 2004/01/08
 */
public class PerceptionLo extends LoServer
	implements LoTop, PerceptionPropertyDef
{

	//////////////////////////////////////////////////////////////////
	// メソッド名定義
	//////////////////////////////////////////////////////////////////
	/** アセスメントリストを取得するメソッドです */
	private static final String METHOD1 = "getAssessmentList";

	/** 結果一覧情報を取得するメソッドです */
	private static final String METHOD2 = "getResultByParticipant";

	/** 受講者個人レポート情報を取得するメソッドです */
	private static final String METHOD3 = "getAccessReport";

	/** PerceptionLOデータを取得するメソッドです */
	private static final String METHOD4 = "selectPerceptionData";

	/**
	 * コンストラクタです。
	 */
	public PerceptionLo() throws LOException, RemoteException {
		// リモートオブジェクトをエクスポートする
		// java.rmi.server.UnicastRemoteObject の
		// 引数なしのコンストラクタを呼び出す
		super();

		// 各共通インターフェース生成
		try {
			mobjMenuMakerIF = new PerceptionMenuMaker();
			mobjLearnManagerIF = new PerceptionLearnManager();
			mobjSetupIF = new PerceptionSetup();
		}
		catch( Exception e ) {
			throw new LOException( this.getClass().getName() + " :: ロード失敗 " );
		}
	}

	/**
	 * 教材一覧を返します
	 *
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと教材一覧
	 */
	public Vector getMaterialList( Hashtable htbParam )
	{
		return new Vector();
	}

	/**
	 * メソッドリストを返します
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータとメソッドリスト
	 */
	public Vector getMethodList(Hashtable htbParam)
	{
		// @pending ここに処理を記述します
		Vector vecRet     = new Vector();
		Object objRet     = null;
		MessageData objMd = null;
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * デフォルトメニューURLを返します
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータとデフォルトメニュー情報
	 */
	public Vector getDefaultMenu(Hashtable htbParam)
	{
		// @pending ここに処理を記述します
		Vector vecRet     = new Vector();
		Object objRet     = null;
		MessageData objMd = null;
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * 各Loに登録されているメソッドを起動します
	 * @param strMehodName 起動するメソッド名
	 * @param objParams 起動するメソッドのパラメータ
	 * @return Vector メッセージデータと実行結果
	 */
	public Vector execute(String strMethodName, Hashtable htbParams)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;

		if( strMethodName.equals( METHOD1 ) )
		{
			vecRet = getAssessmentList( htbParams );
		}
		else if( strMethodName.equals( METHOD2 ) )
		{
			vecRet = getResultByParticipant( htbParams );
		}
		else if( strMethodName.equals( METHOD3 ) )
		{
			vecRet = getAccessReport( htbParams );
		}
		else if( strMethodName.equals( METHOD4 ) )
		{
			vecRet = selectPerceptionData( htbParams );
		}
		return vecRet;
	}

	/**
	 * データ取得処理
	 *
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector getData(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try {
			PerceptionLoDataAccess objDataAccess = new PerceptionLoDataAccess();
			objRet = objDataAccess.getData( htbParam );
		}
		catch(LOException le) {
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * 個別ログの取得を行います
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータと個別ログ取得結果
	 */
	public Vector getIndividualLog( Hashtable htbParam )
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;

		StringBuffer sbCondition = new StringBuffer();
		try
		{
			//検索
			PerceptionLoDataAccess objDataAccess = new PerceptionLoDataAccess();
			PerceptionLoData[] objData = objDataAccess.getData( htbParam );
			vecRet.add( objData );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		// 配列の1番目にメッセージデータを格納
		vecRet.add( 0, objMd );
		return vecRet;
	}

	/**
	 * アセスメントリストの取得を行います
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータ
	 */
	private Vector getAssessmentList( Hashtable htbParam){
		Vector vecRet     = new Vector();
		Vector vecList     = new Vector();
		MessageData objMd = null;
		StringBuffer sbCondition = new StringBuffer();
		try
		{
			// Perception.ini読込
			PerceptionLoEnv objEnv = new PerceptionLoEnv();
			String strQMWISeUrl = objEnv.getQMWISeURL();
			String strClientID = objEnv.getClientID();
			String strChecksum = objEnv.getChecksum();
			String strURI = objEnv.getURI1();
			String strTimeout = objEnv.getTimeout();
			
			// QMWISeに渡すパラメータをリクエストデータオブジェクトにセットします。
			PerceptionRequestData objParam = new PerceptionRequestData();
			objParam.setQMWISeUrl(strQMWISeUrl);
			objParam.setClientID(strClientID);
			objParam.setChecksum(strChecksum);
			objParam.setURI(strURI);
			objParam.setMethodName(METHOD1);
			objParam.setTimeout(strTimeout);
			
DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
DebugLog.write( this.getClass(), "     Perception教材: SOAP Request", DebugLog.ROW );
DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
DebugLog.write( this.getClass(), "QMWISeURL: " + strQMWISeUrl, DebugLog.ROW );
DebugLog.write( this.getClass(), "ClientID: " + strClientID, DebugLog.ROW );
DebugLog.write( this.getClass(), "Checksum: " + strChecksum, DebugLog.ROW );
DebugLog.write( this.getClass(), "URI: " + strURI, DebugLog.ROW );
DebugLog.write( this.getClass(), "Timeout: " + strTimeout, DebugLog.ROW );
			
			// QMWISe通信クラスをインスタンス化します。
			PerceptionCorrespondQMWISe objQMWISe = new PerceptionCorrespondQMWISe(objParam);
			vecList = objQMWISe.CorrespondQMWISe();
			vecRet.add(vecList);
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		// 配列の1番目にメッセージデータを格納
		vecRet.add( 0, objMd );
		return vecRet;
	}

	/**
	 * 結果一覧情報の取得を行います
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータ
	 */
	private Vector getResultByParticipant( Hashtable htbParam){
		Vector vecRet     = new Vector();
		Vector vecList     = new Vector();
		MessageData objMd = null;
		StringBuffer sbCondition = new StringBuffer();
		try
		{
			// Perception.ini読込
			PerceptionLoEnv objEnv = new PerceptionLoEnv();
			String strQMWISeUrl = objEnv.getQMWISeURL();
			String strClientID = objEnv.getClientID();
			String strChecksum = objEnv.getChecksum();
			String strURI = objEnv.getURI2();
			String strTimeout = objEnv.getTimeout();
			
			// QMWISeに渡すパラメータをリクエストデータオブジェクトにセットします。
			PerceptionRequestData objParam = new PerceptionRequestData();
			objParam.setQMWISeUrl(strQMWISeUrl);
			objParam.setClientID(strClientID);
			objParam.setChecksum(strChecksum);
			objParam.setURI(strURI);
			objParam.setMethodName(METHOD2);
			objParam.setTimeout(strTimeout);
			objParam.setUserID((String)htbParam.get(PARTICIPANT_NAME));
			objParam.setAssessmentID((String)htbParam.get(ASSESSMENT_ID));
			
DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
DebugLog.write( this.getClass(), "     Perception教材: SOAP Request", DebugLog.ROW );
DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
DebugLog.write( this.getClass(), "QMWISeURL: " + strQMWISeUrl, DebugLog.ROW );
DebugLog.write( this.getClass(), "ClientID: " + strClientID, DebugLog.ROW );
DebugLog.write( this.getClass(), "Checksum: " + strChecksum, DebugLog.ROW );
DebugLog.write( this.getClass(), "URI: " + strURI, DebugLog.ROW );
DebugLog.write( this.getClass(), "Timeout: " + strTimeout, DebugLog.ROW );
DebugLog.write( this.getClass(), "UserID: " + (String)htbParam.get(PARTICIPANT_NAME), DebugLog.ROW );
			
			// QMWISe通信クラスをインスタンス化します。
			PerceptionCorrespondQMWISe objQMWISe = new PerceptionCorrespondQMWISe(objParam);
			vecList = objQMWISe.CorrespondQMWISe();
			vecRet.add(vecList);
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		// 配列の1番目にメッセージデータを格納
		vecRet.add( 0, objMd );
		return vecRet;
	}

	/**
	 * 受講者個人レポート情報の取得を行います
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータ
	 */
	private Vector getAccessReport( Hashtable htbParam){
		Vector vecRet     = new Vector();
		Vector vecList     = new Vector();
		MessageData objMd = null;
		StringBuffer sbCondition = new StringBuffer();
		try
		{
			// Perception.ini読込
			PerceptionLoEnv objEnv = new PerceptionLoEnv();
			String strQMWISeUrl = objEnv.getQMWISeURL();
			String strClientID = objEnv.getClientID();
			String strChecksum = objEnv.getChecksum();
			String strURI = objEnv.getURI3();
			String strTimeout = objEnv.getTimeout();
			
			// QMWISeに渡すパラメータをリクエストデータオブジェクトにセットします。
			PerceptionRequestData objParam = new PerceptionRequestData();
			objParam.setQMWISeUrl(strQMWISeUrl);
			objParam.setClientID(strClientID);
			objParam.setChecksum(strChecksum);
			objParam.setURI(strURI);
			objParam.setMethodName(METHOD3);
			objParam.setTimeout(strTimeout);
			objParam.setResultID((String)htbParam.get(RESULT_ID));
			
DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
DebugLog.write( this.getClass(), "     Perception教材: SOAP Request", DebugLog.ROW );
DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
DebugLog.write( this.getClass(), "QMWISeURL: " + strQMWISeUrl, DebugLog.ROW );
DebugLog.write( this.getClass(), "ClientID: " + strClientID, DebugLog.ROW );
DebugLog.write( this.getClass(), "Checksum: " + strChecksum, DebugLog.ROW );
DebugLog.write( this.getClass(), "URI: " + strURI, DebugLog.ROW );
DebugLog.write( this.getClass(), "Timeout: " + strTimeout, DebugLog.ROW );
DebugLog.write( this.getClass(), "ResultID: " + (String)htbParam.get(RESULT_ID), DebugLog.ROW );
			
			// QMWISe通信クラスをインスタンス化します。
			PerceptionCorrespondQMWISe objQMWISe = new PerceptionCorrespondQMWISe(objParam);
			vecList = objQMWISe.CorrespondQMWISe();
			vecRet.add(vecList);
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		// 配列の1番目にメッセージデータを格納
		vecRet.add( 0, objMd );
		return vecRet;
	}

	/**
	 * 個別テーブルの検索を行います
	 * @param htbParam パラメータ
	 * @return Vector メッセージデータ
	 */
	public Vector selectPerceptionData( Hashtable htbParam){
		Vector vecRet     = new Vector();
		Object objRet     = null;
		MessageData objMd = null;
		StringBuffer sbCondition = new StringBuffer();
		try
		{
			//検索
			PerceptionLoDataAccess objDataAccess = new PerceptionLoDataAccess();
			PerceptionLoData[] objPerception = objDataAccess.getData( htbParam );
			vecRet.add(objPerception);
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		// 配列の1番目にメッセージデータを格納
		vecRet.add( 0, objMd );
		
		return vecRet;
	}

}
